<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="utility" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="form" uri="http://www.springframework.org/tags/form" %>

<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="flowRequestContext" type="org.springframework.webflow.execution.RequestContext"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>

<template:addResources type="javascript"
                       resources="jquery.min.js,jquery-ui.min.js,admin-bootstrap.js,jquery.tablesorter.js,jquery.blockUI.js,workInProgress.js,bootbox.min.js"/>
<template:addResources type="css" resources="admin-bootstrap.css"/>
<template:addResources type="css" resources="jquery-ui.smoothness.css,jquery-ui.smoothness-jahia.css,tablecloth.css"/>

<fmt:message var="i18nDetails" key="label.remotepublish.history.details"/>

<h2><fmt:message key="label.remotepublish.title"/></h2>

<c:if test="${!isAllowedByLicense}">
    <div>
        <div>
            <div class="alert alert-error">
                <fmt:message key="failure.remotepublish.license"/>
            </div>
        </div>
    </div>
</c:if>

<c:if test="${isAllowedByLicense}">


    <template:addResources type="inlinejavascript">
        <script type="text/javascript">
            function rpSubmitForm(act, rpExecId) {
                $('#rpAction').val(act);
                $('#rpForm').submit();
            }
        </script>
    </template:addResources>


    <div>
    <div>
        <form action="${flowExecutionUrl}" method="post" style="display: inline;" id="rpForm">
            <input type="hidden" id="rpAction" name="_eventId" value=""/>
            <button class="btn" type="submit" name="mybutton" onclick="rpSubmitForm('history'); return false;">
                <i class="icon-arrow-left"></i>
                &nbsp;<fmt:message key="label.remotepublish.back"/>
            </button>
        </form>
    </div>
    <c:if test="${not empty flowRequestContext.messageContext.allMessages}">
        <div>
            <c:forEach items="${flowRequestContext.messageContext.allMessages}" var="message">
                <c:if test="${message.severity eq 'INFO'}">
                    <div class="alert alert-success">
                        <button type="button" class="close" data-dismiss="alert">&times;</button>
                            ${fn:escapeXml(message.text)}
                    </div>
                </c:if>
                <c:if test="${message.severity eq 'ERROR'}">
                    <div class="alert alert-error">
                        <button type="button" class="close" data-dismiss="alert">&times;</button>
                            ${fn:escapeXml(message.text)}
                    </div>
                </c:if>
            </c:forEach>
        </div>
    </c:if>

    <h2><fmt:message key="label.remotepublish.error.${execution.response['error']}"/></h2>
    <fmt:message key="label.remotepublish.error.${execution.response['error']}.details"/>

    <c:choose>
        <c:when test="${execution.response['error'] eq 'INVALID_MODULES'}">
            <div>
                <table class="table table-bordered table-striped table-hover" id="tableRemotePublications">
                    <thead>
                    <tr>
                        <th>
                            <fmt:message key="label.remotepublish.module"/>
                        </th>
                        <th>
                            <fmt:message key="label.remotepublish.version"/>
                        </th>
                    </tr>
                    </thead>
                    <tbody>
                    <c:forEach items="${execution.response['details']}" var="d">
                        <tr>
                            <td>${fn:split(d,"/")[0]}</td>
                            <td>${fn:split(d,"/")[1]}</td>
                        </tr>
                    </c:forEach>
                    </tbody>
                </table>
            </div>
        </c:when>
    </c:choose>
</c:if>
