<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="utility" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="form" uri="http://www.springframework.org/tags/form" %>

<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="flowRequestContext" type="org.springframework.webflow.execution.RequestContext"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>

<template:addResources type="javascript" resources="jquery.min.js,jquery-ui.min.js,admin-bootstrap.js,jquery.blockUI.js,workInProgress.js,bootbox.min.js"/>
<c:set var="uiLang" value="${renderContext.UILocale.language}"/>
<c:set var="jqCronLang" value="${'de' == uiLang || 'fr' == uiLang ? uiLang : 'en'}"/>
<template:addResources type="javascript" resources="jqCron/jqCron.js,jqCron/jqCron.${jqCronLang}.js"/>
<template:addResources type="css" resources="admin-bootstrap.css"/>
<template:addResources type="css" resources="jquery-ui.smoothness.css,jquery-ui.smoothness-jahia.css,jqCron.css"/>

<fmt:message var="i18nWaiting" key="label.workInProgressTitle"/>
<fmt:message var="i18nAdd" key="label.add"/><c:set var="i18nAdd" value="${fn:escapeXml(i18nAdd)}"/>
<fmt:message var="i18nDelete" key="label.delete"/><c:set var="i18nDelete" value="${fn:escapeXml(i18nDelete)}"/>
<fmt:message var="i18nHelp" key="label.help"/>
<fmt:message var="i18nRegenerateJournalHelp" key="label.remotepublish.create.regenerateJournal.help"/>

<c:set var="cronExpressionDefined" value="${not empty remotePublication.scheduleJavaScript}"/>
<template:addResources type="inlinejavascript">
    <script type="text/javascript">
    var myCronInstance = null;
    function enableCronField() {
        if (myCronInstance == null) {
            myCronInstance = $('#scheduleJavaScript').jqCron({
                lang: '${jqCronLang}',
                enabled_minute: true,
                default_period: 'minute',
                numeric_zero_pad: true
            }).jqCronGetInstance();
        }
    }
    $(document).ready(function(){
        <c:if test="${cronExpressionDefined}">
        enableCronField();
        </c:if>
        $('#scheduleToggleAdd').click(function() {
            enableCronField();
            $("#scheduleDiv").show();
            $("#scheduleToggleAdd").hide();
            $("#scheduleToggleRemove").show();
            return false;
        });
        $('#scheduleToggleRemove').click(function() {
            $("#scheduleDiv").hide();
            $("#scheduleJavaScript").val('');
            $("#scheduleToggleRemove").hide();
            $("#scheduleToggleAdd").show();
            return false;
        });
        $('#regenerateJournalHelpLink').click(function () {
            bootbox.alert({
                title: '${functions:escapeJavaScript(i18nHelp)}',
                message: '${functions:escapeJavaScript(i18nRegenerateJournalHelp)}'
            });
        });
    });
    </script>
</template:addResources>

<h2><fmt:message key="${updateMode ? 'label.updateRemotePublication' : 'label.createRemotePublication'}"/></h2>
<div>
    <c:if test="${not empty flowRequestContext.messageContext.allMessages}">
    <div>
        <c:forEach items="${flowRequestContext.messageContext.allMessages}" var="message">
            <c:if test="${message.severity eq 'INFO'}">
                <div class="alert alert-success">
                    <button type="button" class="close" data-dismiss="alert">&times;</button>
                    ${fn:escapeXml(message.text)}
                </div>
            </c:if>
            <c:if test="${message.severity eq 'ERROR'}">
                <div class="alert alert-error">
                    <button type="button" class="close" data-dismiss="alert">&times;</button>
                    ${fn:escapeXml(message.text)}
                </div>
            </c:if>
        </c:forEach>
    </div>
    </c:if>
    <div class="box-1">
        <fmt:message key="label.error.mandatoryField" var="i18nMandatory"/><c:set var="i18nMandatory" value="${fn:escapeXml(i18nMandatory)}"/>
        <c:set var="mandatoryLabel">&nbsp;<span class="text-error" title="${i18nMandatory}"><strong>*</strong></span></c:set>
        <form action="${flowExecutionUrl}" method="post">
            <fieldset>
                <div class="container-fluid">
                    <div class="row-fluid">
                        <div class="span4">
                            <label for="name"><fmt:message key="label.name"/>${mandatoryLabel}</label>
                            <input type="text" name="name" class="span12" id="name" value="${fn:escapeXml(remotePublication.name)}"/>
                        </div>
                    </div>
                    <div class="row-fluid">
                        <div class="span4">
                            <label for="node"><fmt:message key="jnt_remotePublication.node"/>${mandatoryLabel}</label>
                            <input type="text" name="node" class="span12" id="node" value="${renderContext.site.path}" readonly="readonly"/>
                        </div>
                    </div>
                    <div class="row-fluid">
                        <div class="span4">
                            <label for="remoteUrl"><fmt:message key="jnt_remotePublication.remoteUrl"/>${mandatoryLabel}</label>
                            <input type="text" name="remoteUrl" class="span12" id="remoteUrl" value="${fn:escapeXml(remotePublication.remoteUrl)}"/>
                        </div>
                    </div>
                    <div class="row-fluid">
                        <div class="span4">
                            <label for="remoteSiteKey"><fmt:message key="label.remotepublish.remoteSiteKey"/>${mandatoryLabel}</label>
                            <input type="text" name="remoteSiteKey" class="span12" id="remoteSiteKey" value="${fn:escapeXml(remotePublication.remoteSiteKey)}"/>
                        </div>
                    </div>
                    <div class="row-fluid">
                        <div class="span4">
                            <label for="remoteUser"><fmt:message key="jnt_remotePublication.remoteUser"/>${mandatoryLabel}</label>
                            <input type="text" name="remoteUser" class="span12" id="remoteUser" value="root" readonly="readonly"/>
                        </div>
                    </div>
                    <div class="row-fluid">
                        <div class="span4">
                            <label for="remotePassword"><fmt:message key="jnt_remotePublication.remotePassword"/>${mandatoryLabel}</label>
                            <input type="password" name="remotePassword" class="span12" id="remotePassword" value="" autocomplete="off">
                        </div>
                    </div>
                    <div class="row-fluid">
                        <div class="span4">
                            <label for="scheduleJavaScript"><fmt:message key="label.remotepublish.schedule.plan"/></label>
                            <span id="scheduleDiv" ${cronExpressionDefined ? '' : 'style="display: none"'}>
                                <input type="hidden" name="scheduleJavaScript" id="scheduleJavaScript" value="${fn:escapeXml(remotePublication.scheduleJavaScript)}"/>
                            </span>
                            <a href="#add" id="scheduleToggleAdd" title="${i18nAdd}" ${cronExpressionDefined ? ' style="display: none"' : ''}>${i18nAdd}</a>
                            <a href="#remove" id="scheduleToggleRemove" title="${i18nDelete}" ${cronExpressionDefined ? '' : 'style="display: none"'}>${i18nDelete}</a>
                        </div>
                    </div>
                    <br/>
                    <div class="row-fluid">
                        <div class="span4">
                            <label for="testSettings">
                                <input type="checkbox" name="testSettings" id="testSettings" ${remotePublication.testSettings ? 'checked="checked"' : ''}/>
                                <fmt:message key="label.remoteValidate"/>
                            </label>
                            <input type="hidden" name="_testSettings"/>
                        </div>
                    </div>
                    <c:if test="${remotePublication.regenerateJournal != null}">
                        <div class="row-fluid">
                            <div class="span4">
                                <label for="regenerateJournal">
                                    <input type="checkbox" name="regenerateJournal" id="regenerateJournal" ${remotePublication.regenerateJournal ? 'checked="checked"' : ''}/>
                                    <fmt:message key="label.remotepublish.create.regenerateJournal"/>
                                    <a id="regenerateJournalHelpLink" title="${fn:escapeXml(i18nHelp)}" href="#regenerateJournalHelp"><img src="<c:url value='/icons/help.png'/>" width="16" height="16" alt="${fn:escapeXml(i18nHelp)}"></a>
                                </label>
                            </div>
                        </div>
                    </c:if>
                </div>
            </fieldset>

            <p>${mandatoryLabel} - ${i18nMandatory}</p>

            <fieldset>
                <div class="container-fluid">
                    <div class="row-fluid">
                        <div class="span12">
                            <button class="btn btn-primary" type="submit" name="_eventId_${updateMode ? 'update' : 'create'}" onclick="workInProgress('${i18nWaiting}'); return true;">
                                <i class="icon-plus icon-white"></i>
                                &nbsp;<fmt:message key="${updateMode ? 'label.update' : 'label.add'}"/>
                            </button>
                            <button class="btn" type="submit" name="_eventId_cancel">
                                <i class="icon-ban-circle"></i>
                                &nbsp;<fmt:message key='label.cancel'/>
                            </button>
                        </div>
                    </div>
                </div>
            </fieldset>

        </form>
    </div>
</div>
