<%@ page import="org.apache.commons.lang.StringUtils" %>
<%@ page import="org.jahia.modules.remotepublish.RemotePublicationService" %>
<%@ page import="org.jahia.modules.remotepublish.RemotePublishUtils" %>
<%@ page import="org.jahia.services.content.JCRContentUtils" %>
<%@ page import="org.jahia.services.content.JCRSessionFactory" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ page contentType="text/html;charset=UTF-8" language="java" %>
<%
    if (StringUtils.equals(request.getParameter("action"), "setLastReplay")) {
        String currentConfig = request.getParameter("config");
        long lastReplay = Long.parseLong(request.getParameter("lastReplay"));
        boolean isSystemSite = Boolean.parseBoolean(request.getParameter("isSystemSite"));
        if (StringUtils.isNotEmpty(currentConfig)) {
            RemotePublicationService.getInstance().setLastReplay(currentConfig, lastReplay, isSystemSite);
        }
    }
%>
<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">

<c:set var="isRoot" value="<%=JCRSessionFactory.getInstance().getCurrentUser().isRoot()%>"/>

<html xmlns="http://www.w3.org/1999/xhtml">

<head>

    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
    <style type="text/css" title="currentStyle">
        @import "<c:url value="/modules/tools/css/demo_page.css"/>";
        @import "<c:url value="/modules/tools/css/demo_table_jui.css"/>";
    </style>
    <script type="text/javascript" src="<c:url value="/modules/jquery/javascript/jquery.js"/>"></script>
    <script type="text/javascript"
            src="<c:url value="/modules/assets/javascript/datatables/jquery.dataTables.js"/>"></script>
    <script type="text/javascript" src="<c:url value="/modules/assets/javascript/jquery.cuteTime.js"/>"></script>

    <title>Remote Publication management tool</title>

    <script type="text/javascript">

        function callWithWarning(url, site) {

            if (confirm(
                    "Clicking on OK will execute journal regeneration for the path " +
                    site +
                    ", meaning that you will not be able to remote publish your content until you drop and recreate the remote site. Do you want to continue?")) {

                $.get(url, function () {
                }).done(function () {
                    $("#error").html("");
                    $("#process").html("A job has been started to recreate the journal for the path <strong>" + site + "</strong>");
                }).fail(function () {
                    $("#process").html("");
                    $("#error").html("An error occurred while starting a job to recreate the journal for the path <strong>" + site + "</strong>");
                })
            }
        }

        function purgeWithWarning(url, site, date) {

            if (confirm(
                    "Clicking on OK will purge all journal entries before " + date + " for the path " + site + ". Do you want to continue?")) {

                $.get(url, function () {
                }).done(function () {
                    $("#error").html("");
                    $("#process").html("All entries have been purged for site <strong>" + site + "</strong> until <strong>" + date + "</strong> " +
                        "<a href=\"javascript:$('#hiddenInput').attr('name','journals');viewDetails('" + site + "')\">refresh</a>");
                }).fail(function () {
                    $("#process").html("");
                    $("#error").html("An error occurred while purging the journal for the site <strong>" + site + "</strong>");
                })
            }
        }

        function viewDetails(site) {
            $("#hiddenInput").val(site);
            $("#form").submit();
        }

        <c:choose>
        <c:when test="${not empty param['id']}">
        var dataSet = <%=RemotePublishUtils.getEntryDetails(request.getParameter("id"))%>;
        var config = {
            "bPaginate": false,
            "aaData": dataSet,
            "aoColumns": [
                {
                    sTitle: "Count",
                    "sWidth": "50px"
                },
                {
                    sTitle: "Path",
                    "sWidth": "100px"
                },
                {
                    sTitle: "Operation type",
                    "sWidth": "50px"
                },
                {
                    sTitle: "Data",
                    "sWidth": "300px"
                }
            ]
        };
        </c:when>
        <c:when test="${not empty param['journals']}">
        var replays = <%=RemotePublishUtils.getLastReplayInfo(request.getParameter("journals"))%>;
        var dataSet = <%=RemotePublishUtils.getJournalEntries(request.getParameter("journals"),Long.parseLong(request.getParameter("start")),Long.parseLong(request.getParameter("end")))%>;

        for (var i in replays) {
            var lastReplay = replays[i].replay;

            var dataIndex = undefined;
            for (var j in dataSet) {
                if (lastReplay >= dataSet[j][2]) {
                    dataIndex = j;
                }
            }

            if(dataIndex != undefined) {
                if (dataSet[dataIndex][4]) {
                    dataSet[dataIndex][4].push(replays[i].config);
                } else {
                    dataSet[dataIndex].push([replays[i].config]);
                }
            }
        }

        var config = {
            "bPaginate": false,
            "aaData": dataSet,
            "aaSorting": [[ 1, "desc" ]],
            "aoColumns": [
                {
                    sTitle: "ID",
                    "sWidth": "50px",
                    mRender: function (data, type, row) {
                        var s = "";
                        if (row[4]) {
                            for (var i in row[4]) {
                                s += " <a name=\"" + row[4][i] + "\"/>[" + row[4][i] + "] ";
                            }
                        }
                        return data + s ;
                    }
                },
                {
                    sTitle: "Entry date",
                    "sWidth": "50px",
                    sType: "string"
                },
                {
                    sTitle: "Entry timeStamp",
                    "bVisible": false
                },
                {
                    sTitle: "Number of operations",
                    "sWidth": "50px"
                },
                {
                    sTitle: "",
                    "sWidth": "50px",
                    mRender: function (data, type, row) {
                        var res = "<button onclick=\"viewDetails('"+row[0]+"')\">View details</button>";
                        res += "<button " + disabled + " onclick=\"purgeWithWarning('<c:url value="/cms/render/default/en"/><%=request.getParameter("journals")%>.purgeJournal.do?eventDate=" +
                            row[2] + "' , '<%=request.getParameter("journals")%>', '" + row[1] + "')\">Purge this and all previous entries</button>";
                        return res;
                    },
                    "mData": null
                }
            ]
        };
        </c:when>
        <c:otherwise>
        var dataSet = <%=RemotePublishUtils.getJournalsInformation()%>;
        var config = {
            "bPaginate": false,
            "aaData": dataSet,
            "aoColumns": [
                {
                    sTitle: "Base path",
                    "sWidth": "150px"
                },
                {
                    sTitle: "Entries count",
                    "sWidth": "50px"
                },
                {
                    sTitle: "Last entry date",
                    "sWidth": "50px",
                    sType: "string",
                    mRender: function (data, type, row) {
                        return data;
                    }
                },
                {
                    sTitle: "",
                    "sWidth": "50px",
                    mRender: function (data, type, row) {
                        var res = "<button onclick=\"viewDetails('"+row[0]+"')\">View details</button>";
                        res += "<button " + disabled + " onclick=\"callWithWarning('<c:url value="/cms/render/default/en"/>" + row[0] +
                            ".recreateJournal.do', '" + row[0] + "')\">Reset the journal</button>";
                        return res;
                    },
                    "mData": null
                }

            ],
            "aaSorting": [[2, "asc"]]
        };
        </c:otherwise>
        </c:choose>

        $(document).ready(function () {
            disabled = '${isRoot ? "" : "disabled"}';
            $('#remotePublishJournal').DataTable(config);
        })

    </script>

</head>

<body>
<h1>Remote Publication Management Tool</h1>
<p>
<div id="process" style="color:blue"></div>
<div id="error" style="color:red"><c:if test="${!isRoot}">You must be logged as root to use this tool</c:if>&nbsp;</div>
</p>

<form id="form" method="post">
    <input type="hidden" name="toolAccessToken" value="${toolAccessToken}"/>

    <c:choose>
        <c:when test="${not empty param['id']}">
            <button type="submit">Back to  list</button>
            <input type="hidden" name="journals" value="<%=request.getParameter("journals")%>"/>
            <input type="hidden" name="start" value="<%=request.getParameter("start")%>"/>
            <input type="hidden" name="end" value="<%=request.getParameter("end")%>"/>
        </c:when>
        <c:when test="${not empty param['journals']}">
            <button type="button" onclick="window.location.href='remotePublishManagement.jsp'">Back to list</button>
            <input type="hidden" name="id" id="hiddenInput">
            <input type="hidden" name="journals" value="<%=request.getParameter("journals")%>"/>
            <input type="hidden" name="start" value="<%=request.getParameter("start")%>"/>
            <input type="hidden" name="end" value="<%=request.getParameter("end")%>"/>
        </c:when>
        <c:otherwise>
            From : <input name="start" value="1262304000000">
            To : <input name="end" value="2524608000000">
            <input type="hidden" name="journals" id="hiddenInput">
        </c:otherwise>

    </c:choose>
</form>
<c:if test="${not empty param['journals']}">
    <p>
    detail of journal <b>${param['journals']}</b>
    </p>
    <p>
        last entry replayed for config :
        <script  type="application/javascript">
            for (i in replays) {
                var conf = replays[i].config;
                if (replays[i].replay > 0) {
                    document.write("<a href=\"#" + conf + "\">" + conf + "</a> ");
                }

            }
        </script>
    </p>
    <form id="editLastReplay" method="post" action="remotePublishManagement.jsp" onsubmit="return submitForm();">
        <input type="hidden" name="toolAccessToken" value="${toolAccessToken}"/>
        <input type="hidden" name="action" value="setLastReplay"/>
        <input type="hidden" id="isSystemSite" name="isSystemSite" value="<%=StringUtils.equals(request.getParameter("journals"), JCRContentUtils.getSystemSitePath())%>"/>
        <input type="hidden" name="journals" value="<%=request.getParameter("journals")%>"/>
        <input type="hidden" name="start" value="<%=request.getParameter("start")%>"/>
        <input type="hidden" name="end" value="<%=request.getParameter("end")%>"/>
        <input type="hidden" name="lastReplay" value="" id="lastReplay"/>
        <input type="hidden" name="lastReplayDate" value="" id="lastReplayDate"/>

        <p>
            Change last replayed entry for config
            <select name="config" id="config" onchange='$("#lastReplayID").val("")'></select>
            to
            <input type="text" id="lastReplayID" name="lastReplayID"/> ID
            <input type="submit" id="submitLastReplay">
        </p>
    </form>
    <script type="application/javascript">
        function confirmText() {
            return "By changing the value of the last replay property, all the more recent entries in " +
                "the journal for the " + $("#config").val() +
                " configuration will be replayed at the next remote publication execution. Use this feature with " +
                "caution. New value for the last replay " + $("#lastReplayDate").val();
        }
        // fill config select menu
        $.each(replays, function (i, item) {
            if (item.replay > 0) {
                $('#config').append($('<option>', {
                    value: item.config,
                    text: item.config
                }));
            }
        });

        function submitForm() {
            var id = $("#lastReplayID").val();
            $("#lastReplay").val("");
            $("#lastReplayDate").val("");
            $.each(dataSet, function (i, item) {
                if (item[0] == id) {
                    $("#lastReplay").val(item[2]);
                    $("#lastReplayDate").val(item[1]);
                }
            });
            if ($("#lastReplay").val() != "") {
                return confirm(confirmText());
            } else {
                if (id != "") {
                    alert(id + " is not a part of current journal IDs");
                } else {
                    alert("ID is mandatory");
                }
                return false;
            }
        }
    </script>
</c:if>
<table id="remotePublishJournal" class="" width="100%"></table>
<p>
    <img src="<c:url value='/engines/images/icons/home_on.gif'/>" height="16" width="16" alt=" " align="top"/>&nbsp;
    <a href="<c:url value='/modules/tools/index.jsp'/>">to Support Tools overview</a>
</p>
</body>

</html>